#include "Kamera.h"
#include <iostream>
//#include <cmath>

__device__ __host__ Kamera::Kamera(TipProjekcije projekcija, const Vektor4 &pozicija, const Vektor3 &desno, const Vektor3 &gore, const Vektor3 &iza, Realan hfov, int sirina, int visina)
{
  this->projekcija = projekcija;
  this->pozicija = pozicija;
  this->pozicija0 = pozicija;
  this->x = desno;
  this->y = gore;
  this->z = iza;
  u = desno;
  v = gore;
  w = iza;
//  this->u = desno;
//  this->v = gore;
//  this->w = iza;
  this->sirina = sirina;
  this->visina = visina;
  PostaviFOV(hfov);
  //  this->hfov = hfov;
  PostaviGranice();
}

__device__ __host__ void Kamera::PostaviGranice()
{
  r = sirina / 2.0;
  l = -r;
  t = visina / 2.0;
  b = -t;
}

__device__ __host__ void Kamera::PostaviFOV(Realan hfov)
{
  this->hfov = hfov;

  d = (sirina / 2.0f) / tan(hfov / 2.0f);
  //std::cout<<tan(hfov/2.0f)<<'\n';
  //std::cout<<"fokalna:"<<d<<'\n';
}

__device__ __host__ void Kamera::PostaviDimenzije(int sirina, int visina)
{
  this->sirina = sirina;
  this->visina = visina;
  PostaviGranice();
}

__device__ __host__ void Kamera::PostaviDuljinu(Realan d)
{
  this->d = d;

  hfov = atan((sirina / 2.0f) / d) * 2;
}

__device__ __host__ void Kamera::KomponirajTransformaciju(const Matrica4x4 &matrica)
{
  Matrica3x3 linearna = matrica.Linearna();
  // u = linearna * x;
  // v = linearna * y;
  // w = linearna * z;
  u = (linearna * u).Normiraj();
  v = (linearna * v).Normiraj();
  w = (linearna * w).Normiraj();

  pozicija = matrica * pozicija;
  //pozicija = matrica * pozicija0;
}

__device__ __host__ void Kamera::PostaviTransformaciju(const Matrica4x4 &matrica)
{
  Matrica3x3 linearna = matrica.Linearna();
  u = (linearna * x).Normiraj();
  v = (linearna * y).Normiraj();
  w = (linearna * z).Normiraj();

  pozicija = matrica * pozicija0;
}

__device__ __host__ void Kamera::GledajU(const Vektor4 &cilj, const Vektor3 &gore)
{
  Vektor4 tmp0 = cilj;
  Vektor3 tmp1 = gore;

  w = (tmp0 - pozicija).Radijusvektor();
  w = -w.Normiraj();
  u = tmp1 ^ w;
  u = u.Normiraj();
  v = w ^ u;
  v = v.Normiraj();
}

//void Kamera::GledajU(const Vektor4 &cilj)
//{
////w=Vektor3(1, -1,4);
//  Vektor4 tmp = cilj;
//  w = (tmp - pozicija).Radijusvektor();
//  w = -w.Normiraj();
//  Vektor3 t(w[0]+5,w[1],w[2]);
//  u = t ^ w;
//  u = u.Normiraj();
//  v = w ^ u;
//  v = v.Normiraj();
//}

/*
Matrica4x4 Kamera::Transformacija() const
{
  return transformacija;
}
*/

__device__ __host__ Vektor3 Kamera::Pozicija() const
{
  return pozicija.Radijusvektor();
}

__device__ __host__ Realan Kamera::Duljina() const
{
  return d;
}

__device__ __host__ int Kamera::Sirina() const
{
  return sirina;
}

__device__ __host__ int Kamera::Visina() const
{
  return visina;
}

__device__ __host__ const Vektor3 &Kamera::U() const
{
  return u;
}

__device__ __host__ const Vektor3 &Kamera::V() const
{
  return v;
}

__device__ __host__ const Vektor3 &Kamera::W() const
{
  return w;
}
