#include "Kanal.h"

__device__ __host__ Kanal8 operator*(Realan broj, Kanal8 kanal)
{
  Realan tmp = kanal.broj * broj;
  return Kanal8(tmp);
}

__device__ __host__ Kanal8::Kanal8(Realan broj)
{
  //this->broj = static_cast<uint8_t>(broj * 255);
  this->broj = broj;
}

__device__ __host__ Kanal8::Kanal8(unsigned int broj)
{
  this->broj = static_cast<Realan>(broj) / 255;
}

__device__ __host__ Kanal8 Kanal8::operator*(const Kanal8 &kanal)
{
  Realan tmp = kanal.broj * broj;
  return Kanal8(tmp);
  //  return Kanal8(broj);
}

__device__ __host__ Kanal8 Kanal8::operator/(const Kanal8 &kanal)
{
  Realan tmp = broj / kanal.broj;
  return Kanal8(tmp);
}

__device__ __host__ Kanal8 Kanal8::operator+(const Kanal8 &kanal)
{
  Realan tmp = kanal.broj + broj;
  return Kanal8(tmp);
  //  return Kanal8(broj);
}

__device__ __host__ void Kanal8::operator+=(const Kanal8 &kanal)
{
  broj += kanal.broj;
}

__device__ __host__ void Kanal8::operator*=(const Kanal8 &kanal)
{
  broj *= kanal.broj;
}

__device__ __host__ Kanal8 Kanal8::operator-(const Kanal8 &kanal)
{
  Realan tmp = broj - kanal.broj;
  if(tmp < 0.0f)
    return Kanal8(0.0f);

  return Kanal8(tmp);
  //return Kanal8(broj);
}

__device__ __host__ Kanal8::operator Realan()
{
  if(broj > 1.0f)
    return 1.0f;

  return broj;
}

__device__ __host__ Kanal8::operator uint8_t()
{
  if(broj > 1.0f)
    return 255u;
  
  return static_cast<uint8_t>(broj * 255);
}
