#include "KoordinatnaMreza.h"

__device__ __host__ KoordinatnaMreza::KoordinatnaMreza(const Ravnina &ravnina, int zRazmak, int xRazmak, int zJedinicaUdaljenosti, int xJedinicaUdaljenosti, const Vektor3 &zSmjer, const Vektor3 &xSmjer, RGB boja)
{
  this->ravnina = ravnina;
  this->zRazmak = zRazmak;
  this->xRazmak = xRazmak;
  this->zJedinicaUdaljenosti;
  this->xJedinicaUdaljenosti = xJedinicaUdaljenosti;
  this->zSmjer = zSmjer;
  this->xSmjer = xSmjer;
  this->kd = boja;

  tocka = ravnina.udaljenost * ravnina.normala;
}

__device__ __host__ void KoordinatnaMreza::Renderiraj(const Kamera &kamera, const Scena &scena)
{
  Vektor3 tocka1, tocka2, delta;
  Vektor3 centar;
  int dZ, dX, z, x;
  int mod;

  centar = ((kamera.Pozicija().Radijusvektor() * ravnina.normala) - ravnina.udaljenost) * (-ravnina.normala) + kamera.Pozicija().Radijusvektor();
  delta = centar - tocka;
  dZ = static_cast<int>(zSmjer * delta);
  dX = static_cast<int>(xSmjer * delta);

  mod = dZ % zRazmak;
  if (mod != 0)
    dZ -= mod;

  mod = dX % xRazmak;
  if (mod != 0)
    dX -= mod;

  centar = tocka + zSmjer * dZ + xSmjer * dX;
  for (z = 0; z < xLimitPola; z += xRazmak)
  {
    tocka1 = centar + xSmjer * z;
    tocka2 = tocka1 + zSmjer * zLimitPola;
    scena.DodajObjekt(Pravac(tocka1.DajTocku(), tocka2.DajTocku()));
    tocka1 = tocka2 - zSmjer * zLimitPola;
    tocka2 = tocka1 - zSmjer * zLimitPola;
    scena.DodajObjekt(Pravac(tocka1.DajTocku(), tocka2.DajTocku()));
  }
}

__device__ __host__ KoordinatnaMreza::~KoordinatnaMreza()
{
}
