#pragma once
#include "Ravnina.h"
#include "Kamera.h"
#include "ScenaGPU.h"
#include "RGB.h"

class KoordinatnaMreza
{
    public:
        __device__ __host__ KoordinatnaMreza(const Ravnina &, int, int, int, int, const Vektor3 &, const Vektor3 &, RGB boja={128,128,128});
        __device__ __host__ ~KoordinatnaMreza();

	__device__ __host__ KoordinatnaMreza(const KoordinatnaMreza &) = default;
	__device__ __host__ KoordinatnaMreza & operator=(const KoordinatnaMreza &) = default;
	__device__ __host__ KoordinatnaMreza(KoordinatnaMreza &&) = default;
	__device__ __host__ KoordinatnaMreza & operator=(const KoordinatnaMreza &&) = default;

        __device__ __host__ void Renderiraj(const Kamera &,const Scena &);
    protected:
    private:
    Ravnina ravnina;
    int zRazmak;
    int xRazmak;
    RGB kd;
    Vektor3 zSmjer;
    Vektor3 xSmjer;

    Vektor3 tocka;
    int zLimitPola, zLimit;//limiti udaljenosti iscrtavanja
    int xLimitPola, xLimit;

    int zJedinicaUdaljenosti = 500;
    int xJedinicaUdaljenosti = 500;
};
