#include "Kvadar.h"
#include <cfloat>

Kvadar::Kvadar(Realan a, Realan b, Realan c, RGB boja)
{
  this->a = a;
  this->b = b;
  this->c = c;

  Vektor4 v1 = Vektor4(0, 0, 0, 1);
  Vektor4 v2 = Vektor4(a, 0, 0, 1);
  Vektor4 v3 = Vektor4(a, 0, c, 1);
  Vektor4 v4 = Vektor4(0, 0, c, 1);
  Vektor4 v5 = Vektor4(0, b, 0, 1);
  Vektor4 v6 = Vektor4(a, b, 0, 1);
  Vektor4 v7 = Vektor4(a, b, c, 1);
  Vektor4 v8 = Vektor4(0, b, c, 1);

  t[0] = Trokut(v1, v2, v3, boja);
  t[1] = Trokut(v1, v3, v4, boja);

  t[2] = Trokut(v2, v1, v5, boja);
  t[3] = Trokut(v5, v6, v2, boja);
  //t[2] = Trokut(v1, v2, v6, {0, 255, 0});
  //t[3] = Trokut(v1, v6, v5, {0, 255, 0});

  t[4] = Trokut(v7, v3, v2, boja);
  t[5] = Trokut(v6, v7, v2, boja);

  t[6] = Trokut(v8, v4, v3, boja);
  t[7] = Trokut(v3, v7, v8, boja);
  //t[6] = Trokut(v4, v8, v3, boja);
  //t[7] = Trokut(v8, v7, v3, boja);

  t[8] = Trokut(v7, v6, v5, boja);
  t[9] = Trokut(v5, v8, v7, boja);

  t[10] = Trokut(v5, v1, v4, boja);
  t[11] = Trokut(v4, v8, v5, boja);
}

void Kvadar::Transformiraj()
{
  for(int i = 0; i < 12; ++i)
  {
    t[i].transformacija = transformacija;
    t[i].Transformiraj();
  }
}

bool Kvadar::PresijeciZraku(const Zraka &zraka, Realan &t0)
{
  Realan t1 = BESKONACNO;
  for(int i = 0; i < 12; ++i)
  {
    if(t[i].PresijeciZraku(zraka, t0))
    {
      if(t0 < t1)
      {
        t1 = t0;
        presjecenTrokut = i;
      }
    }
  }

  if(presjecenTrokut == -1)//if(t1 == DBL_MAX)
    return false;

  t0 = t1;
  return true;
}

inline RGB Kvadar::Sjencaj(const std::forward_list<Svjetlo *> &svjetla)
{
  return t[presjecenTrokut].Sjencaj(svjetla);
}
