#include "Matrica4x4.h"
#include <iostream>
#include <cstring>
//#include <cmath>

__device__ __host__ Matrica4x4::Matrica4x4()
{
  memset(m, 0, 16 * sizeof(Realan));
}

__device__ __host__ Matrica4x4::Matrica4x4(Realan m11, Realan m12, Realan m13, Realan m14, Realan m21, Realan m22, Realan m23, Realan m24, Realan m31, Realan m32, Realan m33, Realan m34, Realan m41, Realan m42, Realan m43, Realan m44)
{
  m[3][3] = m44;
  m[3][2] = m43;
  m[3][1] = m42;
  m[3][0] = m41;
  m[2][3] = m34;
  m[2][2] = m33;
  m[2][1] = m32;
  m[2][0] = m31;
  m[1][3] = m24;
  m[1][2] = m23;
  m[1][1] = m22;
  m[1][0] = m21;
  m[0][3] = m14;
  m[0][2] = m13;
  m[0][1] = m12;
  m[0][0] = m11;
}

__device__ __host__ Matrica4x4::Matrica4x4(const Realan elementi[4][4])
{
  memcpy (m, elementi, 16 * sizeof(Realan));
}

/*


Matrica4x4::Matrica4x4 (const Matrica4x4 &mat)
{
  memcpy (m, mat.m, 16 * sizeof(Realan));
}

Matrica4x4 & Matrica4x4::operator=(const Matrica4x4 &mat)
{
  memcpy (m, mat.m, 16 * sizeof(Realan));
  return *this;
}

Matrica4x4 & Matrica4x4::operator=(const Matrica4x4 &&mat)
{
  memcpy (m, mat.m, 16 * sizeof(Realan));
  ///memset (mat.m, 0, 16 * sizeof(double)); ovo bi trebalo biti!
  return *this;
}
*/

__device__ __host__ Matrica4x4 Matrica4x4::operator+(const Matrica4x4 &mat) const
{
  Realan n[4][4];
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      n[i][j] = m[i][j] + mat.Element(i, j);
  /*  int n11 = m[0][0] + mat.Element(0, 0);
  int n12 = m[0][1] + mat.Element(0, 1);
  int n13 = m[0][2] + mat.Element(0, 2);
  int n14 = m[0][3] + mat.Element(0, 3);
  int n21 = m[1][0] + mat.Element(1, 0);
  int n22 = m[1][1] + mat.Element(1, 1);
  int n23 = m[1][2] + mat.Element(1, 2);
  int n24 = m[1][3] + mat.Element(1, 3);
  int n31 = m[2][0] + mat.Element(2, 0);
  int n32 = m[2][1] + mat.Element(2, 1);
  int n33 = m[2][2] + mat.Element(2, 2);
  int n34 = m[2][3] + mat.Element(2, 3);
  int n41 = m[3][0] + mat.Element(3, 0);
  int n42 = m[3][1] + mat.Element(3, 1);
  int n43 = m[3][2] + mat.Element(3, 2);
  int n44 = m[3][3] + mat.Element(3, 3);*/
  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 Matrica4x4::operator-(const Matrica4x4 &mat) const
{
  Realan n[4][4];
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      n[i][j] = m[i][j] - mat.Element(i, j);

  return Matrica4x4(n);
}

__device__ __host__ void Matrica4x4::operator-()
{
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      m[i][j] = -m[i][j];
}

__device__ __host__ Realan Matrica4x4::Element(int i, int j) const
{
  return m[i][j];
}

__device__ __host__ bool Matrica4x4::operator==(const Matrica4x4 &matB) const
{
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      if (fabs((matB.Element(i, j) - m[i][j])) < epsilon)
      //if (m[i][j] != matB.Element(i, j))
	return false;

  return true;
}

__device__ __host__ bool Matrica4x4::operator!=(const Matrica4x4 &matB) const
{
  return !operator==(matB);
}

__device__ __host__ Matrica4x4 operator*(const Matrica4x4 &matA, const Matrica4x4 &matB)//tes const
{
  Realan n[4][4] = {{0}};
  //memset (n, 0, 16 * sizeof(double));
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      for (int k = 0; k < 4; ++k)
#ifdef FP_FAST_FMA
	n[i][j] = fma (matA.Element(i, k), matB.Element(k, j), n[i][j]);
#else
  n[i][j] += matA.Element(i, k) * matB.Element(k, j);
#endif

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 operator*(Realan skalar, const Matrica4x4 &mat)
{
  Realan n[4][4];
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      n[i][j] = mat.Element(i, j) * skalar;

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 operator*(const Matrica4x4 &mat, Realan skalar)
{
  return operator*(skalar, mat);//?
}

__device__ __host__ Matrica4x4 Matrica4x4::Transponiraj() const
{
  Realan n[4][4];
  for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
      n[i][j] = m[j][i];

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 Matrica4x4::Skaliraj(Realan uniform)
{
  return Matrica4x4(uniform, 0, 0, 0,
		    0, uniform, 0, 0,
		    0, 0, uniform, 0,
		    0, 0, 0, 1);
}

//inline double Matrica4x4::Minora(int i, int j) const
//{


__device__ __host__ Realan Matrica4x4::Determinanta()
{
  if (determinantaSpremna)
    return determinanta;
  //else

#ifdef FP_FAST_FMA
  t1 = fma (m[1][0], m[3][3], -m[2][3] * m[3][2]);
  t2 = fma (m[2][1], m[3][3], -m[2][3] * m[3][1]);
  t3 = fma (m[2][1], m[3][2], -m[2][2] * m[3][1]);
  t4 = fma (m[2][0], m[3][3], -m[2][3] * m[3][0]);
  t5 = fma (m[2][0], m[3][2], -m[2][2] * m[3][0]);
  t6 = fma (m[2][0], m[3][1], -m[2][1] * m[3][0]);

  m1 = fma (m[1][1], t1, fma (-m[1][2], t2, m[1][3] * t3));
  m2 = fma (m[1][0], t1, fma (-m[1][2], t4, m[1][3] * t5));
  m3 = fma (m[1][0], t2, fma (-m[1][1], t4, m[1][3] * t6));
  m4 = fma (m[1][0], t3, fma (-m[1][1], t5, m[1][2] * t6));

  determinanta = fma (m[0][0], m1, fma (-m[0][1], m2, fma (m[0][2], m3, -m[0][3] * m4)));
#else
  t1 = m[2][2] * m[3][3] - m[2][3] * m[3][2];
  t2 = m[2][1] * m[3][3] - m[2][3] * m[3][1];
  t3 = m[2][1] * m[3][2] - m[2][2] * m[3][1];
  t4 = m[2][0] * m[3][3] - m[2][3] * m[3][0];
  t5 = m[2][0] * m[3][2] - m[2][2] * m[3][0];
  t6 = m[2][0] * m[3][1] - m[2][1] * m[3][0];

  m1 = m[1][1] * t1 - m[1][2] * t2 + m[1][3] * t3;
  m2 = m[1][0] * t1 - m[1][2] * t4 + m[1][3] * t5;
  m3 = m[1][0] * t2 - m[1][1] * t4 + m[1][3] * t6;
  m4 = m[1][0] * t3 - m[1][1] * t5 + m[1][2] * t6;

  determinanta = m[0][0] * m1 - m[0][1] * m2 + m[0][2] * m3 - m[0][3] * m4;
#endif

  determinantaSpremna = true;
  return determinanta;
}

__device__ __host__ Matrica4x4 Matrica4x4::Invertiraj()
{
  if (!determinantaSpremna)
    Determinanta();

  if (fabs(determinanta) < epsilon)
    {
      return Matrica4x4();
    }
  //else

#ifdef FP_FAST_FMA
  Realan t7 = fma (m[1][2], m[3][3], -m[1][3] * m[3][2]);
  Realan t8 = fma (m[1][1], m[3][3], -m[1][3] * m[3][1]);
  Realan t9 = fma (m[1][1], m[3][2], -m[1][2] * m[3][1]);
  Realan t10 = fma (m[1][0], m[3][3], -m[1][3] * m[3][0]);
  Realan t11 = fma (m[1][0], m[3][2], -m[1][2] * m[3][0]);
  Realan t12 = fma (m[1][0], m[3][1], -m[1][1] * m[3][0]);
  Realan t13 = fma (m[1][2], m[2][3], -m[1][3] * m[2][2]);
  Realan t14 = fma (m[1][1], m[2][3], -m[1][3] * m[2][1]);
  Realan t15 = fma (m[1][1], m[2][2], -m[1][2] * m[2][1]);
  Realan t16 = fma (m[1][0], m[2][3], -m[1][3] * m[2][0]);
  Realan t17 = fma (m[1][0], m[2][2], -m[1][2] * m[2][0]);
  Realan t18 = fma (m[1][0], m[2][1], -m[1][1] * m[2][0]);

  Realan m5 = fma (m[0][1], t1, fma (-m[0][2], t2, m[0][3] * t3));
  Realan m6 = fma (m[0][0], t1, fma (-m[0][2], t4, m[0][3] * t5));
  Realan m7 = fma (m[0][0], t2, fma (-m[0][1], t4, m[0][3] * t6));
  Realan m8 = fma (m[0][0], t3, fma (-m[0][1], t5, m[0][2] * t6));
  Realan m9 = fma (m[0][1], t7, fma (-m[0][2], t8, m[0][3] * t9));
  Realan m10 = fma (m[0][0], t7, fma (-m[0][2], t10, m[0][3] * t11));
  Realan m11 = fma (m[0][0], t8, fma (-m[0][1], t10, m[0][3] * t12));
  Realan m12 = fma (m[0][0], t9, fma (-m[0][1], t11, m[0][2] * t12));
  Realan m13 = fma (m[0][1], t13, fma (-m[0][2], t14, m[0][3] * t15));
  Realan m14 = fma (m[0][0], t13, fma (-m[0][2], t16, m[0][3] * t17));
  Realan m15 = fma (m[0][0], t14, fma (-m[0][1], t16, m[0][3] * t18));
  Realan m16 = fma (m[0][0], t15, fma (-m[0][1], t17, m[0][2] * t18));
#else
  Realan t7 = m[1][2] * m[3][3] - m[1][3] * m[3][2];
  Realan t8 = m[1][1] * m[3][3] - m[1][3] * m[3][1];
  Realan t9 = m[1][1] * m[3][2] - m[1][2] * m[3][1];
  Realan t10 = m[1][0] * m[3][3] - m[1][3] * m[3][0];
  Realan t11 = m[1][0] * m[3][2] - m[1][2] * m[3][0];
  Realan t12 = m[1][0] * m[3][1] - m[1][1] * m[3][0];
  Realan t13 = m[1][2] * m[2][3] - m[1][3] * m[2][2];
  Realan t14 = m[1][1] * m[2][3] - m[1][3] * m[2][1];
  Realan t15 = m[1][1] * m[2][2] - m[1][2] * m[2][1];
  Realan t16 = m[1][0] * m[2][3] - m[1][3] * m[2][0];
  Realan t17 = m[1][0] * m[2][2] - m[1][2] * m[2][0];
  Realan t18 = m[1][0] * m[2][1] - m[1][1] * m[2][0];

  Realan m5 = m[0][1] * t1 - m[0][2] * t2 + m[0][3] * t3;
  Realan m6 = m[0][0] * t1 - m[0][2] * t4 + m[0][3] * t5;
  Realan m7 = m[0][0] * t2 - m[0][1] * t4 + m[0][3] * t6;
  Realan m8 = m[0][0] * t3 - m[0][1] * t5 + m[0][2] * t6;
  Realan m9 = m[0][1] * t7 - m[0][2] * t8 + m[0][3] * t9;
  Realan m10 = m[0][0] * t7 - m[0][2] * t10 + m[0][3] * t11;
  Realan m11 = m[0][0] * t8 - m[0][1] * t10 + m[0][3] * t12;
  Realan m12 = m[0][0] * t9 - m[0][1] * t11 + m[0][2] * t12;
  Realan m13 = m[0][1] * t13 - m[0][2] * t14 + m[0][3] * t15;
  Realan m14 = m[0][0] * t13 - m[0][2] * t16 + m[0][3] * t17;
  Realan m15 = m[0][0] * t14 - m[0][1] * t16 + m[0][3] * t18;
  Realan m16 = m[0][0] * t15 - m[0][1] * t17 + m[0][2] * t18;
#endif

  return (1 / determinanta * Matrica4x4(m1, -m5, m9, -m13, -m2, m6, -m10, m14, m3, -m7, m11, -m15, -m4, m8, -m12, m16));
}

__device__ __host__ Matrica3x3 Matrica4x4::Linearna() const
{
  return Matrica3x3(m[0][0], m[0][1], m[0][2], m[1][0], m[1][1], m[1][2], m[2][0], m[2][1], m[2][2]);
}

__device__ __host__ Matrica4x4 Matrica4x4::Jedinicna()
{
  Realan n[4][4] = {{1., 0., 0., 0.}, {0., 1., 0., 0.}, {0., 0., 1., 0.}, {0., 0., 0., 1.}};

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 Matrica4x4::RotirajX(Realan radijana)
{
  Realan n[4][4] = {{1}};
  //  n[0][0] = 1;
  n[1][1] = cos(radijana);
  n[1][2] = -sin(radijana);
  n[2][1] = sin(radijana);
  n[2][2] = cos(radijana);
  n[3][3] = 1;

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 Matrica4x4::RotirajY(Realan radijana)
{
  Realan n[4][4] = {{0}};
  n[0][0] = cos(radijana);
  n[0][2] = sin(radijana);
  n[1][1] = 1;
  n[2][0] = -sin(radijana);
  n[2][2] = cos(radijana);
  n[3][3] = 1;

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 Matrica4x4::RotirajZ(Realan radijana)
{
  Realan n[4][4] = {{0}};
  n[0][0] = cos(radijana);
  n[0][1] = -sin(radijana);
  n[1][0] = sin(radijana);
  n[1][1] = cos(radijana);
  n[2][2] = 1;
  n[3][3] = 1;

  return Matrica4x4(n);
}

__device__ __host__ Matrica4x4 Matrica4x4::Translatiraj(const Vektor3& vektor)
{
  Vektor3 tmp = vektor;

  Realan n[4][4] = {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}};
  n[0][3] = tmp[0];
  n[1][3] = tmp[1];
  n[2][3] = tmp[2];
  n[3][3] = 1;

  return Matrica4x4(n);
}
