#include "Pravac.h"
//#include <cmath>

__device__ __host__ Pravac::Pravac(const Vektor4 &tocka, const Vektor3 &smjer, RGB boja)
{
  this->tocka = tocka;
  this->smjer = smjer;
  //this->smjer2 = ortogonalanSmjer;
  kd = boja;
  //kd = Vektor3(boja.crvena / 255.0, boja.zelena / 255.0, boja.plava / 255.0);
}

__device__ __host__ Pravac::Pravac(const Vektor4 &tocka1, const Vektor4 &tocka2,RGB boja)
{
  tocka = tocka1;
  Vektor4 t2(tocka2), t1(tocka1);
  smjer = (t2 - t1).Radijusvektor();
  kd = boja;
}

__device__ __host__ void Pravac::Transformiraj()
{
  tocka = transformacija * tocka;
  smjer = transformacija.Linearna() * smjer;
}

__device__ bool Pravac::PresijeciZraku(const Zraka &zraka, Realan &t)
{
  Vektor3 e = zraka.Ishodiste();
  Vektor3 d = zraka.Smjer();

  Vektor3 odKamereDoPravca = tocka.Radijusvektor() - e;
  //Vektor3 odKamereDoSjecista = tocka.Radijusvektor() - kamera.Pozicija();
  smjer2 = odKamereDoPravca ^ smjer;
  smjer2.Normiraj();

  Matrica3x3 A(d[0], -smjer[0], -smjer2[0], d[1], -smjer[1], -smjer2[1], d[2], -smjer[2], -smjer2[2]);
  Realan D = A.Determinanta();
  if(fabs(D) < 1.0e-6)
    return false;

  t = Matrica3x3(tocka[0] - e[0], -smjer[0], -smjer2[0], tocka[1] - e[1], -smjer[1], -smjer2[1], tocka[2] - e[2], -smjer[2], -smjer2[2]).Determinanta() / D;
  if(t < 0)
    return false;

  Realan beta = Matrica3x3(d[0], -smjer[0], tocka[0] - e[0], d[1], -smjer[1], tocka[1] - e[1], d[2] - smjer[2], -smjer[2], tocka[2] - e[2]).Determinanta() / D;
  if(beta > debljina || beta < -debljina)//postigni željenu debljinu pravca
    return false;

  return true;
}

__device__ RGB Pravac::Sjencaj(const Svjetlo svjetla[], size_t n)
{
  return kd;
}
