#pragma once
#include "SDLIntegracija.h"
#include <functional>
#include <iostream>

class SDLIntegracija;

class Prozor
{
 public:
  Prozor(const SDLIntegracija &, std::string naslov, int sirina, int visina);
  ~Prozor();
  void PromjeniVelicinu(int sirina, int visina);
  void Unisti();
  void Vsync(Uint32 *pikseli);

  void PoveziIzlaz(std::function<bool()> izlazHandler);
  void PoveziPromjenu(std::function<void(std::pair<int,int>)> promjenaHandler);
  void PoveziTipke(std::function<void(SDL_Keycode)> tipkaHandler);

  bool operator==(const Prozor &prozor2)
  {
    return (prozor == prozor2.DajProzor());
  }

  int DajSirinu() const {return w;}
  int DajVisinu() const {return h;}
  std::string DajNaslov() const {return naslov;}
  SDL_Window *DajProzor() const {return prozor;}

 private:
  int w, h;
  std::string naslov;
  SDL_Window *prozor;
  SDL_Renderer *renderer;
  SDL_Texture *raster;
  
  void UloviEvente();
  void PromjeniVelicinuEvent(int sirina, int visina);
  
  std::function<bool()> izlaz = [&](){
    std::cout << "Prozor " << SDL_GetWindowID(prozor) << " se zatvara"
    << std::endl; Unisti(); return true;};
  
  std::function<void(std::pair<int,int>)> promjenaVelicine = [](std::pair<int,int> noveDim){std::cout << "Nova širina: " << noveDim.first << std::endl
											    << "Nova visina: " << noveDim.second << std::endl;};
  
  std::function<void(SDL_Keycode)> stisnutaTipka = [](SDL_Keycode tipka){
    std::cout << "Stisnuta je tipka " << SDL_GetKeyName(tipka) << std::endl;
  };
};
