#include "Sfera.h"
#include <cmath>

//Sfera::Sfera(double radijus, RGB difuznaBoja) : R(radijus), kd(difuznaBoja) {}
Sfera::Sfera(Realan radijus, RGB difuznaBoja)
{
  R = radijus;
  reciprocR = 1 / R;
  kd = Vektor3(difuznaBoja[0] / Kanal8(255.0f), difuznaBoja[1] / Kanal8(255.0f), difuznaBoja[2] / Kanal8(255.0f));
  //kd = difuznaBoja;
}

Sfera::Sfera(Realan radijus)
{
  R = radijus;
  reciprocR = 1 / R;
}
//Sfera::Sfera(double radijus) : R(radijus) {}

Realan sign(Realan x)
{
  if (x > 0)
    return 1;
  else if (x == 0)
    return 0;
  else
    return -1;
}

void Sfera::Transformiraj()
{
}

bool Sfera::PresijeciZraku(const Zraka &zraka, Realan &t)
{
  Vektor3 c = Vektor3(transformacija.Element(0, 3), transformacija.Element(1, 3), transformacija.Element(2, 3));
  Vektor3 e = zraka.Ishodiste();
  Vektor3 d = zraka.Smjer();
  Vektor3 u = e - c;
  Realan D = pow(d * u, 2) - (d * d) * (u * u - R * R);

  if (D < 0)
    return false;
  //else

  Realan t1 = -(d * u - sign(d * u) * sqrt(D)) / (d * d);
  ///double t1 = -(d * u + sign(d * u) * sqrt(D)) / (d * d);

///  double t2;

  ///if (fabs(D) < 1.0e-6)
///    t2 = t1;

///  else
///    t2 = (u * u - R * R) / ((d * d) * t1);

  sjeciste = e + d * t1;
  t = t1;
///  sjeciste = e + d * t2;
///  t = t2;
  return true;
}

RGB Sfera::Sjencaj(const std::forward_list<Svjetlo *> &svjetla)
{
  Vektor3 c = Vektor3(transformacija.Element(0, 3), transformacija.Element(1, 3), transformacija.Element(2, 3));
  Vektor3 normala = (sjeciste - c) * reciprocR;
  Kanal8 r = 0u, g = 0u, b = 0u;
  for(auto svjetlo : svjetla)
  {
    Vektor3 l = (svjetlo->DajPoziciju().Radijusvektor() - sjeciste).Normiraj();
    Realan m = fmax(0, normala * l);
    r += kd[0] * (svjetlo->boja[0] * Kanal8(m));
    g += kd[1] * (svjetlo->boja[1] * Kanal8(m));
    b += kd[2] * (svjetlo->boja[2] * Kanal8(m));
  }

  /*
  if(r > 1.0)
    r = 1.0;
  if(g > 1.0)
    g = 1.0;
  if(b > 1.0)
  b = 1.0;*/
  return RGB{r, g, b};

  //return RGB{static_cast<uint8_t>(255 * r), static_cast<uint8_t>(255 * g), static_cast<uint8_t>(255 * b)};
}
