#pragma once
#include "Matrica4x4.h"
//#include "Vektor3.h"
#include "RGB.h"

/** Tip jednostavnog, točkovnog izvora svjetlosti.
 */
class Svjetlo//točkovni izvor svjetlosti
{
 private:
  /** Pozicija svjetla u svjetskom prostoru.
   */
  Vektor4 pozicija;
  //  Vektor3 smjer;//ne koristi se za ovakvo svjetlo

 public:
  __device__ __host__ Svjetlo() = default;
  /** Konstruktor svjetla s pozicijom i bojom.
   *  \param[in] poz  Pozicija svjetla u svjetskom prostoru.
   *  \param[in] boja Boja svjetla.
   */
  __device__ __host__ Svjetlo(const Vektor3 &poz, RGB boja);
  __device__ __host__ ~Svjetlo() = default;

  __device__ __host__ Svjetlo(const Svjetlo &) = default;
  __device__ __host__ Svjetlo & operator=(const Svjetlo &) = default;
  __device__ __host__ Svjetlo(Svjetlo &&) = default;
  __device__ __host__ Svjetlo & operator=(Svjetlo &&) = default;

  /** RGB boja svjetla.
   */
  RGB boja;
  /** Općenita transformacija svjetla.
   */
  Matrica4x4 transformacija = Matrica4x4::Jedinicna();

  __device__ __host__ const Vektor4 &DajPoziciju() const;
  //__device__ __host__ const Vektor3 &DajSmjer() const;

  /** Primijeni zadanu transformaciju na svjetlo.
   */
  __device__ __host__ void Transformiraj();
};
