#pragma once
#include "Vektor4.h"
#include "Vektor3.h"

/** Tip zrake u 3-prostoru.
 */
class Zraka
{
 private:
  Vektor3 ishodiste;
  Vektor3 smjer;

 public:
  /** Konstruktor zrake s ishodištem i ciljem.
   *  \param[in] o Točka ishodišta.
   *  \param[in] c Točka cilja.
   */
  __device__ __host__ Zraka(Vektor4 &o,Vektor4 &c);
  /** Konstruktor zrake s ishodištem i smjerom.
   *  \param[in] o     Točka ishodišta.
   *  \param[in] smjer Smjer zrake.
   */
  __device__ __host__ Zraka(Vektor4 &o,Vektor3 &smjer);
  /** Konstruktor zrake s ishodištem i smjerom.
   *  \param[in] o     Točka ishodišta.
   *  \param[in] smjer Smjer zrake.
   */
  __device__ __host__ Zraka(Vektor3 &o,Vektor3 &smjer);
  __device__ __host__ ~Zraka() = default;

  __device__ __host__ Zraka(const Zraka &) = default;
  __device__ __host__ Zraka & operator=(const Zraka &) = default;
  __device__ __host__ Zraka(Zraka &&) = default;
  __device__ __host__ Zraka & operator=(Zraka &&) = default;

  __device__ __host__ const Vektor3 &Ishodiste() const {return ishodiste;}
  __device__ __host__ const Vektor3 &Smjer() const {return smjer;}
  //__device__ __host__ const Vektor3 &Ishodiste() const;
  //__device__ __host__ const Vektor3 &Smjer() const;
};
