/*
Copyright Mauro Raguzin GPLv3 2019
*/
#include "MatBaza.h"
#include "SDLIntegracija.h"
#include "Svjetlo.h"
#include "Kvadar.h"
#include "Trokut.h"
#include "Kamera.h"
#include "Pravac.h"
#include "Sfera.h"
#include "Scena.h"
#include "Slika.h"
#include <iostream>
#include <memory>
#include <cmath>
#ifdef __EMSCRIPTEN__
#include <emscripten.h>
#endif

  int w = 350, h = 350;//početna rezolucija
  Realan hfov = 90;
  Vektor4 gledajU(-40, -20, -200, 1);
  Matrica4x4 ukupnaKamera=Matrica4x4::Jedinicna();
  auto tipKamere = Kamera::TipProjekcije::Perspektivna;

  SDL_Window *prozor;
  SDL_Renderer *renderer;

///Slika slika(w, h);
///SlikaGPU slikaGPU(w, h);

  SDL_Texture *rasterskaSlika;// = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
    Sfera jednaSfera(20);
    Sfera drugaSfera(15,{0u,0u,255u});
    Sfera desnaSfera(65,{255u,255u,0u});
    Sfera lijevaSfera(65,{255u,128u,0u});
    Kvadar kocka0(5, 5, 5);
    Kvadar kvadar1(17, 5, 3,{4u, 255u, 30u});
    Pravac pravac0(Vektor4(-10, 5, -65, 1), Vektor3(0, 0, -1));

    Svjetlo svjetlo0(Vektor3(), {255u, 255u, 255u});
    Svjetlo svjetlo1(Vektor3(-5, 50, -500),{128u,255u,65u});
    Kamera kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);//160°
///ScenaGPU scenaGpu;
///Scena scena;

void Iteracija()
{
    static Realan rotacija=0;
    rotacija+=Radijana(10);
    kocka0.transformacija=Matrica4x4::Translatiraj(Vektor3(0,0,-10)) * Matrica4x4::RotirajY(rotacija);

      SDL_Event event;
      /*
      
      while(SDL_PollEvent(&event))
      {
        switch(event.type)
        {

          case SDL_QUIT:
            SDL_DestroyRenderer(renderer);
            for(int i = 0; i < 10*2; ++i)
            delete pravci[i];
            //delete slika;
            exit(0);
            //return -1;

          case SDL_WINDOWEVENT:
            if(event.window.event == SDL_WINDOWEVENT_RESIZED)
            {
              w = event.window.data1;
              h = event.window.data2;
              std::cout<<"w:"<<w<<" h:"<<h<<'\t';
              kamera = Kamera(Kamera::TipProjekcije::Perspektivna, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
              slika.reset(new Slika(kamera, scena));
              //delete slika;
              //slika = new Slika (kamera, scena);
              SDL_DestroyTexture(rasterskaSlika);
              rasterskaSlika = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
            }
            break;

          case SDL_KEYDOWN:
            switch(event.key.keysym.sym)
            {
              case SDLK_KP_PLUS:
                hfov -= 10;//SMANJI fov
                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
                break;

              case SDLK_KP_MINUS:
                hfov += 10;
                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
                break;

              case SDLK_RETURN:
                if(tipKamere == Kamera::TipProjekcije::Perspektivna)
                  tipKamere = Kamera::TipProjekcije::Ortografska;
                else
                  tipKamere = Kamera::TipProjekcije::Perspektivna;

                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
                break;

              case SDLK_UP:
                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.W()) * ukupnaKamera;
                break;

              case SDLK_DOWN:
                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.W()) * ukupnaKamera;
                break;

              case SDLK_PAGEUP:
                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.V()) * ukupnaKamera;
                break;

              case SDLK_PAGEDOWN:
                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.V()) * ukupnaKamera;
                break;

              case SDLK_RIGHT:
                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.U()) * ukupnaKamera;
                break;

              case SDLK_LEFT:
                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.U()) * ukupnaKamera;
                break;

              case SDLK_c:
                SDL_SetWindowSize(prozor, w - 100, h - 100);
                SDL_Event noviEvent;
                noviEvent.type = SDL_WINDOWEVENT;
                noviEvent.window.event = SDL_WINDOWEVENT_RESIZED;
                noviEvent.window.data1 = w - 100;
                noviEvent.window.data2 = h - 100;
                SDL_PushEvent(&noviEvent);
                break;
            }
            break;
        }
      }

      scena.TransformirajObjekte();
      kamera.PostaviTransformaciju(ukupnaKamera);
      kamera.GledajU(gledajU, Vektor3(0, 1, 0));
      slika->Raytrace();

      SDL_UpdateTexture(rasterskaSlika, nullptr, slika->DajSliku().get(), w * 4);
      SDL_RenderClear(renderer);
      SDL_RenderCopy(renderer, rasterskaSlika, nullptr, nullptr);
      SDL_RenderPresent(renderer);
      */
}

int main(int argc, char *args[])
{
  std::cout << "Copyright Mauro Raguzin GPLv3 2019\n\nUporaba: numpad - odzumirava (povećava FOV); numpad + zumira (smanjuje FOV); strelice orbitiraju kameru oko jedne točke; pgup/pgdn podižu/spuštaju kameru\nENTER mijenja tip projekcije\nSMANJITE prozor sa slovom C za bolje performanse!" << std::endl;

  SDLIntegracija sdl(SDL_INIT_VIDEO);

//  SDL_Window *prozor;
//  SDL_Renderer *renderer;
  int greska = SDL_CreateWindowAndRenderer(w, h, SDL_WINDOW_RESIZABLE, &prozor, &renderer);
  if(greska == -1)
    std::cout << "Prozor nije mogao biti stvoren!" << std::endl;

  else
  {
    SDL_SetWindowTitle(prozor, "Seminarski rad - raytracer (Mauro Raguzin)");
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
    SDL_RenderClear(renderer);
    SDL_RenderPresent(renderer);

rasterskaSlika = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);

    kvadar1.transformacija=Matrica4x4::Translatiraj(Vektor3(-10, 3, -4)) * Matrica4x4::RotirajX(23);
    drugaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(-40,20,-110));
    jednaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(0, 0, -100));
    desnaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(90, -5, -50));
    lijevaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(-90, -5, -50));

    /*
    for(int i = 0; i < 10; ++i)//pripremi koordinatnu mrežu
    {
      pravci[i] = new Pravac(Vektor4(-1000+700, -20, 0, 1) + Vektor4(100 * i, 0, 0, 0), Vektor3(0, 0, 1));
      scena.DodajObjekt(*pravci[i]);
    }

    for(int i = 10; i < 10*2; ++i)
    {
      pravci[i] = new Pravac(Vektor4(-1000-400, -20, -2000, 1) + Vektor4(0, 0, 100 * i, 0), Vektor3(1, 0, 0));
      scena.DodajObjekt(*pravci[i]);
    }

    scena.DodajObjekt(kocka0);
    scena.DodajObjekt(kvadar1);
    scena.DodajObjekt(jednaSfera);
    scena.DodajObjekt(drugaSfera);
    scena.DodajObjekt(desnaSfera);
    scena.DodajObjekt(lijevaSfera);
    scena.DodajObjekt(pravac0);
    scena.DodajSvjetlo(svjetlo1);
    scena.DodajSvjetlo(svjetlo0);
    slika.reset(new Slika(kamera, scena));
    //slika = new Slika(kamera,scena);
    */

#ifdef __EMSCRIPTEN__
    emscripten_set_main_loop(&Iteracija, 0, 1);
#else
    while(1)
    {
      Iteracija();

    }
#endif // __EMSCRIPTEN__
    SDL_DestroyRenderer(renderer);
    //for(int i = 0; i < 10*2; ++i)
    //delete pravci[i];

  }

  return 0;
}
