/*
Copyright Mauro Raguzin GPLv3 2015
--kompajlirati s opcijom -lSDL2; mora biti instaliran libsdl2-dev i SDL.h dostupan u SDL2 include direktoriju
*/
#include "SDLIntegracija.h"
#include "Svjetlo.h"
#include "Kvadar.h"
#include "Trokut.h"
#include "Kamera.h"
#include "Pravac.h"
#include "Sfera.h"
#include "Scena.h"
#include "Slika.h"
#include "SDL2/SDL.h"
#include <iostream>
#include <cmath>
#ifdef __EMSCRIPTEN__
#include <emscripten.h>
#endif

double Radijana(double stupnjeva)
{
  return (stupnjeva / 180 * M_PI);
}

  int w = 350, h = 350;//početna rezolucija
  double hfov = 90;
  Vektor4 gledajU(-40, -20, -200, 1);
  Matrica4x4 ukupnaKamera=Matrica4x4::Jedinicna();
  Kamera::TipProjekcije tipKamere = Kamera::TipProjekcije::Perspektivna;

  SDL_Window *prozor;
  SDL_Renderer *renderer;
  Slika *slika;

  SDL_Texture *rasterskaSlika;// = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
    Sfera jednaSfera(20);
    Sfera drugaSfera(15,{0,0,255});
    Sfera desnaSfera(65,{255,255,0});
    Sfera lijevaSfera(65,{255,128,0});
    Kvadar kocka0(5, 5, 5);
    Kvadar kvadar1(17, 5, 3,{4, 255, 30});
    Pravac pravac0(Vektor4(-10, 5, -65, 1), Vektor3(0, 0, -1));

    Svjetlo svjetlo0(Vektor3(), {255, 255, 255});
    Svjetlo svjetlo1(Vektor3(-5, 50, -500),{128,255,65});
    Kamera kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);//160°
    Scena scena;
    Pravac *pravci[65*2];//neiskorišteno za sada

void Iteracija()//(Vektor4 &gledajU, Kvadar &kocka0, Kamera &kamera, Scena &scena, Kamera::TipProjekcije &tipKamere, Matrica4x4 &ukupnaKamera, int &w, int &h, Slika *&slika, SDL_Texture *&rasterskaSlika, double &hfov, SDL_Renderer *&renderer)
{
    static double rotacija=0;
    rotacija+=Radijana(10);
    //kvadar0.transformacija=Matrica4x4::RotirajX(rotacija);
    kocka0.transformacija=Matrica4x4::Translatiraj(Vektor3(0,0,-10)) * Matrica4x4::RotirajY(rotacija);
    //kvadar0.transformacija=Matrica4x4::RotirajX(rotacija);
    //trokut0.transformacija=Matrica4x4::RotirajX(rotacija);
      SDL_Event event;
      while(SDL_PollEvent(&event))
      {
        switch(event.type)
        {

          case SDL_QUIT:
            SDL_DestroyRenderer(renderer);
            for(int i = 0; i < 10*2; ++i)
            delete pravci[i];
            delete slika;
            exit(0);
            //return -1;

          case SDL_WINDOWEVENT:
            if(event.window.event == SDL_WINDOWEVENT_RESIZED)
            {
              w = event.window.data1;
              h = event.window.data2;
              std::cout<<"w:"<<w<<" h:"<<h<<'\t';
              kamera = Kamera(Kamera::TipProjekcije::Perspektivna, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
              slika = new Slika (kamera, scena);
              SDL_DestroyTexture(rasterskaSlika);
              rasterskaSlika = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
            }
            break;

          case SDL_KEYDOWN:
            switch(event.key.keysym.sym)
            {
              case SDLK_KP_PLUS:
                hfov -= 10;//SMANJI fov
                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
                break;

              case SDLK_KP_MINUS:
                hfov += 10;
                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
                break;

              case SDLK_RETURN:
                if(tipKamere == Kamera::TipProjekcije::Perspektivna)
                  tipKamere = Kamera::TipProjekcije::Ortografska;
                else
                  tipKamere = Kamera::TipProjekcije::Perspektivna;

                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
                break;

              case SDLK_UP:
                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.W()) * ukupnaKamera;
                break;

              case SDLK_DOWN:
                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.W()) * ukupnaKamera;
                break;

              case SDLK_PAGEUP:
                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.V()) * ukupnaKamera;
                break;

              case SDLK_PAGEDOWN:
                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.V()) * ukupnaKamera;
                break;

              case SDLK_RIGHT:
                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.U()) * ukupnaKamera;
                break;

              case SDLK_LEFT:
                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.U()) * ukupnaKamera;
                break;

              case SDLK_c:
                //w -= 100;
                //h -= 100;
                SDL_SetWindowSize(prozor, w - 100, h - 100);
                //w -= 100;
                //h -= 100;
                SDL_Event noviEvent;
                noviEvent.type = SDL_WINDOWEVENT;
                noviEvent.window.event = SDL_WINDOWEVENT_RESIZED;
                noviEvent.window.data1 = w - 100;
                noviEvent.window.data2 = h - 100;
                SDL_PushEvent(&noviEvent);
                break;
            }
            break;
        }
      }

      scena.TransformirajObjekte();
      kamera.PostaviTransformaciju(ukupnaKamera);
      kamera.GledajU(gledajU);
      slika->Raytrace();

      SDL_UpdateTexture(rasterskaSlika, nullptr, slika->DajSliku(), w * 4);
      SDL_RenderClear(renderer);
      SDL_RenderCopy(renderer, rasterskaSlika, nullptr, nullptr);
      SDL_RenderPresent(renderer);
}

int main(int argc, char *args[])
{
  std::cout << "Copyright Mauro Raguzin GPLv3 2015\n\nUporaba: numpad - odzumirava (povećava FOV); numpad + zumira (smanjuje FOV); strelice orbitiraju kameru oko jedne točke; pgup/pgdn podižu/spuštaju kameru\nENTER mijenja tip projekcije\nSMANJITE prozor sa slovom C za bolje performanse!" << std::endl;

//  int w = 65, h = 65;//početna rezolucija
//  double hfov = 90;
//  Vektor4 gledajU(-40, -20, -200, 1);
//  Matrica4x4 ukupnaKamera=Matrica4x4::Jedinicna();
//  Kamera::TipProjekcije tipKamere = Kamera::TipProjekcije::Perspektivna;
  SDLIntegracija sdl(SDL_INIT_VIDEO);

//  SDL_Window *prozor;
//  SDL_Renderer *renderer;
  int greska = SDL_CreateWindowAndRenderer(w, h, SDL_WINDOW_RESIZABLE, &prozor, &renderer);
  if(greska == -1)
    std::cout << "Prozor nije mogao biti stvoren!" << std::endl;

  else
  {
    SDL_SetWindowTitle(prozor, "Seminarski rad - raytracer (Mauro Raguzin)");
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
    SDL_RenderClear(renderer);
    SDL_RenderPresent(renderer);

//    SDL_Texture *rasterskaSlika = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
rasterskaSlika = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
//    Sfera jednaSfera(20);
//    Sfera drugaSfera(15,{0,0,255});
//    Sfera desnaSfera(65,{255,255,0});
//    Sfera lijevaSfera(65,{255,128,0});
//    Kvadar kocka0(5, 5, 5);
//    Kvadar kvadar1(17, 5, 3,{4, 255, 30});
    kvadar1.transformacija=Matrica4x4::Translatiraj(Vektor3(-10, 3, -4)) * Matrica4x4::RotirajX(23);
    drugaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(-40,20,-110));
    jednaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(0, 0, -100));
    desnaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(90, -5, -50));
    lijevaSfera.transformacija = Matrica4x4::Translatiraj(Vektor3(-90, -5, -50));
//    Svjetlo svjetlo0(Vektor3(), {255, 255, 255});
//    Svjetlo svjetlo1(Vektor3(-5, 50, -500),{128,255,65});
//    Kamera kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);//160°
//    Scena scena;
//    Pravac *pravci[65*2];
    for(int i = 0; i < 10; ++i)//pripremi koordinatnu mrežu
    {
      pravci[i] = new Pravac(Vektor4(-1000+700, -20, 0, 1) + Vektor4(100 * i, 0, 0, 0), Vektor3(0, 0, 1));
      //scena.DodajObjekt(*pravci[i]);
    }

    for(int i = 10; i < 10*2; ++i)
    {
      pravci[i] = new Pravac(Vektor4(-1000-400, -20, -2000, 1) + Vektor4(0, 0, 100 * i, 0), Vektor3(1, 0, 0));
      //scena.DodajObjekt(*pravci[i]);
    }

    scena.DodajObjekt(kocka0);
    scena.DodajObjekt(kvadar1);
    scena.DodajObjekt(jednaSfera);
    scena.DodajObjekt(drugaSfera);
    scena.DodajObjekt(desnaSfera);
    scena.DodajObjekt(lijevaSfera);
    scena.DodajObjekt(pravac0);
    scena.DodajSvjetlo(svjetlo1);
    scena.DodajSvjetlo(svjetlo0);
    slika = new Slika(kamera,scena);
    //Slika *slika = new Slika(kamera, scena);

#ifdef __EMSCRIPTEN__
    emscripten_set_main_loop(&Iteracija, 0, 1);
#else
    while(1)
    {
      Iteracija();
      //if(Iteracija(gledajU, kocka0, kamera, scena, tipKamere, ukupnaKamera, w, h, slika, rasterskaSlika, hfov, renderer) == -1)
        //break;
//    rotacija+=Radijana(10);
//    //kvadar0.transformacija=Matrica4x4::RotirajX(rotacija);
//    kocka0.transformacija=Matrica4x4::Translatiraj(Vektor3(0,0,-10)) * Matrica4x4::RotirajY(rotacija);
//    //kvadar0.transformacija=Matrica4x4::RotirajX(rotacija);
//    //trokut0.transformacija=Matrica4x4::RotirajX(rotacija);
//      SDL_Event event;
//      while(SDL_PollEvent(&event))
//      {
//        switch(event.type)
//        {
//          case SDL_KEYDOWN:
//            switch(event.key.keysym.sym)
//            {
//              case SDLK_KP_PLUS:
//                hfov -= 10;//SMANJI fov
//                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
//                break;
//
//              case SDLK_KP_MINUS:
//                hfov += 10;
//                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
//                break;
//
//              case SDLK_RETURN:
//                if(tipKamere == Kamera::TipProjekcije::Perspektivna)
//                  tipKamere = Kamera::TipProjekcije::Ortografska;
//                else
//                  tipKamere = Kamera::TipProjekcije::Perspektivna;
//
//                kamera = Kamera(tipKamere, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
//                break;
//
//              case SDLK_UP:
//                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.W()) * ukupnaKamera;
//                break;
//
//              case SDLK_DOWN:
//                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.W()) * ukupnaKamera;
//                break;
//
//              case SDLK_PAGEUP:
//                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.V()) * ukupnaKamera;
//                break;
//
//              case SDLK_PAGEDOWN:
//                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.V()) * ukupnaKamera;
//                break;
//
//              case SDLK_RIGHT:
//                ukupnaKamera = Matrica4x4::Translatiraj(10 * kamera.U()) * ukupnaKamera;
//                break;
//
//              case SDLK_LEFT:
//                ukupnaKamera = Matrica4x4::Translatiraj(-10 * kamera.U()) * ukupnaKamera;
//                break;
//            }
//            break;
//
//          case SDL_QUIT:
//            SDL_DestroyRenderer(renderer);
//            return 0;
//
//          case SDL_WINDOWEVENT:
//            if(event.window.event == SDL_WINDOWEVENT_RESIZED)
//            {
//              w = event.window.data1;
//              h = event.window.data2;
//              kamera = Kamera(Kamera::TipProjekcije::Perspektivna, Vektor4(0, 0, 10, 1), Vektor3(1, 0, 0), Vektor3(0, 1, 0), Vektor3(0, 0, 1), Radijana(hfov), w, h);
//              slika = new Slika (kamera, scena);
//              SDL_DestroyTexture(rasterskaSlika);
//              rasterskaSlika = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGB888, SDL_TEXTUREACCESS_STREAMING, w, h);
//            }
//            break;
//        }
//      }
//
//      scena.TransformirajObjekte();
//      kamera.PostaviTransformaciju(ukupnaKamera);
//      kamera.GledajU(gledajU);
//      slika->Raytrace();
//
//      SDL_UpdateTexture(rasterskaSlika, nullptr, slika->DajSliku(), w * 4);
//      SDL_RenderClear(renderer);
//      SDL_RenderCopy(renderer, rasterskaSlika, nullptr, nullptr);
//      SDL_RenderPresent(renderer);
    }
#endif // __EMSCRIPTEN__
    SDL_DestroyRenderer(renderer);
    for(int i = 0; i < 10*2; ++i)
    delete pravci[i];
    delete slika;

  }

  return 0;
}
